Has patch: No
Complexity:
Subject: Http request does not handle X-Forwarded-Proto headers consistently
Description

The Http\Request currently only checks the X-Forwarded-Proto header in isSecure(). But it fails to verify it correctly and it ignores the
header when fetching the URI from the current request:
Given:

GET http://acme.com:8080 HTTP/1.1
X-Forwarded-Proto: https
X-Forwarded-Port: 443

1(string)$currentHttpRequest->getUri();

EXPECTED:https://acme.com
ACTUAL:http://acme.com:8080

Related issues:
related to TYPO3.Neos - Bug # 54435: Absolute URIs in Ext.Direct requests do ... Closed 2013-12-15

Associated revisions
Revision ca7d52f5 - 2013-12-16 14:44 - Bastian Waidelich

[BUGFIX] Respect X-Forwarded-Proto header consistently

The ``Http\Request`` currently only considers ``X-Forwarded-Proto``
headers in its isSecure() method.

With this change the header is checked in the constructor so that it
overrules the requested protocol if set.

Before::
GET http://acme.com:8080 HTTP/1.1
 X-Forwarded-Proto: https
 X-Forwarded-Port: 443

Generated URIs like ``http://acme.com:8080``. With this change the
result is ``https://acme.com``.
Change-Id: If12eee73208b29049d543a9563a3b42161b1f024
Fixes: #54453
Releases: 2.0, master

Revision a5c33983 - 2014-01-16 10:49 - Bastian Waidelich

[BUGFIX] Respect X-Forwarded-Proto header consistently

The ``Http\Request`` currently only considers ``X-Forwarded-Proto``
headers in its isSecure() method.

With this change the header is checked in the constructor so that it
overrules the requested protocol if set.

Before::
GET http://acme.com:8080 HTTP/1.1
 X-Forwarded-Proto: https
 X-Forwarded-Port: 443

Generated URIs like ``http://acme.com:8080``. With this change the
result is ``https://acme.com``.

Change-Id: If12eee73208b29049d543a9563a3b42161b1f024
Fixes: #54453
Releases: 2.0, 2.1, master

History
#1 - 2013-12-16 14:44 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/26450

#2 - 2013-12-17 16:36 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ca7d52f5f458f8191980ec41f9df21fb495286f1.

#3 - 2014-01-16 10:49 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/26868
#4 - 2014-07-11 20:19 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:a5c3398363278a2c28fd67f4edca58f448c420a1.
